Name:           mkosi
Version:        20.1
Release:    1%{?dist}
Summary:        Create bespoke OS images

License:        LGPL-2.1-or-later
URL:            https://github.com/systemd/mkosi
Source0:         https://github.com/systemd/mkosi/archive/v%{version}/%{name}-%{version}.tar.gz

BuildArch:      noarch
BuildRequires:  python3-devel
BuildRequires:  pyproject-rpm-macros
BuildRequires:  python3-pytest
BuildRequires:  pandoc

%bcond tests 1

%global __brp_compress true

Requires:       python3
Requires:       bubblewrap
Requires:       coreutils

Recommends:     python3dist(argcomplete)

Recommends:     systemd

Recommends:     systemd-container >= 254

Recommends:     systemd-udev >= 254
Recommends:     systemd-ukify >= 254

Recommends:     systemd-repart >= 254

Recommends:     acl

Recommends:     kmod

Recommends:     openssl
Recommends:     sbsigntools
Recommends:     gnupg

Recommends:     (dnf5 or dnf)
Recommends:     apt
Recommends:     debian-keyring
Recommends:     pacman
Recommends:     archlinux-keyring
Recommends:     zypper

Recommends:     btrfs-progs
Recommends:     e2fsprogs
Recommends:     dosfstools
Recommends:     mtools
Recommends:     erofs-utils
Recommends:     xfsprogs
Recommends:     squashfs-tools

Recommends:     cpio
Recommends:     tar

Recommends:     qemu-kvm-core
Recommends:     edk2-ovmf
Recommends:     swtpm

Recommends:     openssh-clients
Recommends:     socat

Recommends:     zstd
Recommends:     xz

%description
A fancy wrapper around "dnf --installroot", "apt-get", "pacman", "zypper", and
"emerge" to generate disk images with a number of bells and whistles.

Generated images are tailored to the purpose. This means GPT disk labels are
used and only systemd-based images may be generated.

%prep
%autosetup -p1

%generate_buildrequires
%pyproject_buildrequires

%build
tools/make-man-page.sh

%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files mkosi

mkdir -p %{buildroot}%{_mandir}/man1
ln -s -t %{buildroot}%{_mandir}/man1/ \
         ../../../..%{python3_sitelib}/mkosi/resources/mkosi.1

%files -f %pyproject_files
%license LICENSE
%doc README.md
%_bindir/mkosi
%_mandir/man1/mkosi.1*

%check
%if %{with tests}
%pytest tests/ -v
%endif

%changelog
* Fri Aug 23 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 20.1-1
- initial build
